local _
local rematch = Rematch
local old_PLAYER_TARGET_CHANGED = rematch.PLAYER_TARGET_CHANGED
local saved
local settings
local hhh
local doeverywhere
local silent
local C_PetJournal = C_PetJournal
local GetBestMapForUnit = C_Map.GetBestMapForUnit
local GetMapInfo = C_Map.GetMapInfo
local ADDON_NAME, namespace = ... 	--strange stuff
local version = GetAddOnMetadata(ADDON_NAME, "Version")

--local GetAreaInfo = C_Map.GetAreaInfo --there doesn't seem to be a reliable way to obtain player's current area ID
--[[
BfA info

    Function will be replaced in 8.0

mapInfo = C_Map.GetMapInfo(storyMapID || mapID)

    mapInfo is a table
    example output for C_Map.GetMapInfo(84)

{
   mapID = 84,
   mapType = 3,
   name = "Stormwind City",
   parentMapID = 13
}

--]]
rematch:InitModule(function()
	saved = RematchSaved
	settings = RematchSettings
	if not settings.RematchCelestialTournament then
		settings.RematchCelestialTournament = {["do_everywhere"] = false}
		settings.RematchCelestialTournament = {["silent"] = false}
	end
	doeverywhere = settings.RematchCelestialTournament.do_everywhere
	silent = settings.RematchCelestialTournament.silent
	----[[
	if saved.RematchCelestialTournament then
		saved.RematchCelestialTournament = nil
	end
	----]]
	local prev_version = settings.RematchCelestialTournament.installed_version
	if prev_version ~= version then
		DEFAULT_CHAT_FRAME:AddMessage("New addon version |cFF00FF00" .. version .. "|r for " .. ADDON_NAME .." loaded. Type|cFFC0C0C0 /rmtcelest|r for options.")
		settings.RematchCelestialTournament = {["installed_version"] = version}
	end
	--[[
		if not saved.RematchCelestialTournament then
		saved.RematchCelestialTournament = {["do_everywhere"] = false}
	end
	--]]
	
	--doeverywhere = saved.RematchCelestialTournament.do_everywhere
end)
--if temp == 905 then print ("It's Shrine of Seven Stars") end
--if temp == 955 then print ("It's Celestial Tournament") end
--if temp == 903 then print ("It's Shrine of Two Moons") end
--if temp == 976 then print ("It's Horde Garrison") end
--if temp == 321 then print ("It's Orgrimmar") end
local textmessage

local where_to_execute = {
	--[955] = {}, --Celestial Tournament
	--[1127] = {}, --supposedly, Wailing Caverns pet battle dungeon
	--[1137] = {}, --supposedly, The Deadmines pet battle dungeon
	--[11] = {}, --Wailing Caverns --before instance
	--[55] = {}, --Deadmines --before instance
	--[226] = {}, --Gnomeregan --Hall of Gears; Grubbis
	--[227] = {}, --Gnomeregan --Dormitory; Viscious Fallout, Electrucioner 6000
	--[228] = {}, --Gnomeregan --Launch Bay; Crowd Pummeler 9-60
	--[229] = {}, --Gnomeregan --Tinker's Court; Mekgineer Thermaplugg
	--[279] = {}, --Wailing Caverns --normal dungeon
	--[291] = {}, --Deadmines --Deadmines (First Floor); Glubtok, Helix Gearbreaker
	--[292] = {}, --Deadmines --Ironclad Cove; Foe Reaper, etc
	[571] = {}, --Celestial Tournament --seemingly pet battle dungeon
	[825] = {}, --Wailing Caverns --seemingly pet battle dungeon
	[835] = {}, --Deadmines --seemingly pet battle dungeon floor 1
	[836] = {}, --Deadmines --seemingly pet battle dungeon floor 2
	[840] = {}, --Gnomeregan --seemingly pet battle dungeon floor 1
	[841] = {}, --Gnomeregan --seemingly pet battle dungeon floor 2
	[842] = {}, --Gnomeregan --seemingly pet battle dungeon floor 3
}
local function my_PLAYER_TARGET_CHANGED(self)
	--local saved = RematchSaved
	local temp = GetBestMapForUnit("player")
	--local temp=GetCurrentMapAreaID()
	--SetMapToCurrentZone()
	--print(temp)
	--local temp1=GetCurrentMapAreaID()
	--print(temp1)
	--can't make temp1 and temp2 different
	--[[
	local ccount = 0;
	local lastid = 0;
	local mapinfo,mapname
	for i = 1,10000 do

		mapinfo = GetMapInfo(i)
		if mapinfo then
			ccount = ccount + 1
			lastid = i
			mapname = mapinfo.name
			--print(mapname)
			if string.find(mapname,"eadmine") or string.find(mapname,"ailing") or string.find(mapname,"Celest") or string.find(mapname,"Frostwal") or string.find(mapname,"Lunarfal") or string.find(mapname,"Gnomereg") then
				print("GetMapInfo",i,mapname)
			end
		end

	if 1 == 0 then
		mapname = GetAreaInfo(i) --uncomment local GetAreaInfo = C_Map.GetAreaInfo in case of error
		if mapname then
			ccount = ccount + 1
			lastid = i
			if string.find(mapname,"eadmine") or string.find(mapname,"ailing") or string.find(mapname,"Celest")  or string.find(mapname,"Hillsb") or string.find(mapname,"Gnomereg")then
				print("GetAreaInfo",i,mapname)
			--6771 CT
			--8528 WC
			--8630 DM
			end
		end

		mapname = GetRealZoneText(i)
		if mapname and mapname ~="" then
			ccount = ccount + 1
			lastid = i
			if string.find(mapname,"eadmine") or string.find(mapname,"ailing") or string.find(mapname,"Celest") or string.find(mapname,"Hillsb") or string.find(mapname,"Gnomereg")then
				print("GetRealZoneText",i,mapname)
			end
			--1161 CT
			--1697 WC
			--1688 DM
		end
	end
	end
	print("-------")
	print("number of maps",ccount)
	print("last map id", lastid)
	--mapinfo = GetMapInfo(temp)
	--mapname = mapinfo.name
	--print("This is",mapname,"with ID",temp)
	--]]
	if where_to_execute[temp] or doeverywhere then
		if saved["Heal team"] then
			local healID = saved["Heal team"][1][1]
			local hhealth,hmaxHealth = C_PetJournal.GetPetStats(healID)
			local numDead = 0
			local numInjured = 0
			local numPets = C_PetJournal.GetNumPets()
			if hmaxHealth == hhealth then
				--rematch:LoadTeam("Heal team")
				local most_injured_ID = nil
				local most_injured_deficit = 0
				local least_injured_ID = nil
				local least_injured_deficit = 10000
				for i=1, numPets do
					local petID = C_PetJournal.GetPetInfoByIndex(i)
					if petID then
						local health, maxHealth = C_PetJournal.GetPetStats(petID)
						if health == 0 then numDead = numDead + 1 end
						if health < maxHealth and health > 0 then
							local deficit = maxHealth - health
							numInjured = numInjured + 1
							if most_injured_deficit < deficit then
								most_injured_ID = petID
								most_injured_deficit = deficit
							end
							if least_injured_deficit > deficit then
								least_injured_ID = petID
								least_injured_deficit = deficit
							end
						end
					end
				end
				if numInjured > 0 then
					C_PetJournal.SetPetLoadOutInfo(1, healID)
					C_PetJournal.SetPetLoadOutInfo(2, most_injured_ID)
					if numInjured > 1 then
						C_PetJournal.SetPetLoadOutInfo(3, least_injured_ID)
					end
				end
				--print(format("You have %s injured pets and %s dead pets.",tostring(numInjured),tostring(numDead)))
			else --you asked for this by letting your healing pet to get injured
				hhh = {}
				for i=1, numPets do
					local petID = C_PetJournal.GetPetInfoByIndex(i)
					if petID then
						local health,maxHealth = C_PetJournal.GetPetStats(petID)
						if health == 0 then numDead = numDead + 1 end
						if health < maxHealth and health > 0 then
							numInjured = numInjured + 1
							hhh[numInjured] = petID
						end
					end
				end
				if hhealth == 0 then
					DEFAULT_CHAT_FRAME:AddMessage("Pet intended to do the healing is dead")
				else
					for i=1, 3 do
						C_PetJournal.SetPetLoadOutInfo(i, hhh[i])
					end
					C_PetJournal.SetPetLoadOutInfo(1, healID)
				end
				--print(format("You have %s injured pets and %s dead pets.",tostring(numInjured),tostring(numDead)))
			end
			DEFAULT_CHAT_FRAME:AddMessage("You have " .. numInjured .. " injured pets and " .. numDead .. " dead pets." )
			--print(format("You have %s injured pets and %s dead pets.",tostring(numInjured),tostring(numDead))) --printing here doesn't seem to work
			if numInjured == 0 then
				local name,npcID = rematch:GetUnitNameandID("target")
				if saved[npcID] then
					DEFAULT_CHAT_FRAME:AddMessage("Since there are no injured pets, loaded team for " .. name)
					rematch:LoadTeam(npcID)
				end
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("Healing team not defined")
		end
	else
		if not silent then
			--SetMapByID(temp)
			--GetRealZoneText()
			local mapinfo = GetMapInfo(temp)
			if not textmessage then
				local commonids = ""
				local commonnames = ""
				--[[
				for zoneid,_ in pairs(where_to_execute) do
					local place = GetMapNameByID(zoneid)
					commonids = commonids .. zoneid .. ", "
					commonnames = commonnames .. place .. ", "
				end
				--]]
				for zoneid,_ in pairs(where_to_execute) do
					local mapinfo = GetMapInfo(zoneid)
					commonids = commonids .. ", " .. zoneid
					commonnames = commonnames .. ", " .. mapinfo.name
				end
				textmessage = ", a loading of different team for healing is meant for zones with ID " .. commonids .. " - " .. commonnames .."."
				textmessage = textmessage:gsub(" , "," ")
			end
			--DEFAULT_CHAT_FRAME:AddMessage("It's " .. GetRealZoneText() .. " or " .. tst .. " with zone ID " .. temp .. textmessage)
			--DEFAULT_CHAT_FRAME:AddMessage("It's " .. mapinfo.name .. " with zone ID " .. temp .. textmessage)
			DEFAULT_CHAT_FRAME:AddMessage("It's " .. GetRealZoneText() .. " or " .. mapinfo.name .. " with map ID " .. temp .. textmessage)
		end
	end
end

function rematch:PLAYER_TARGET_CHANGED()
	if IsShiftKeyDown() then
		local name,npcID = rematch:GetUnitNameandID("target")
		if saved[npcID] then
			DEFAULT_CHAT_FRAME:AddMessage("There's a saved team meant for defeating " .. name)
		end
		--rematch.recentTarget = nil
		return my_PLAYER_TARGET_CHANGED(self)
	else
		return old_PLAYER_TARGET_CHANGED(self)
	end
end

SLASH_RMTCELEST1 = "/rmtcelest";
function SlashCmdList.RMTCELEST(msg)
	local wasnotrecognized = true
	if msg =="status" then
		wasnotrecognized = false
		if doeverywhere then
			DEFAULT_CHAT_FRAME:AddMessage("Loading of healing team is currently enabled |cFFFF0000 for each zone|r")
		else
			DEFAULT_CHAT_FRAME:AddMessage("Loading of healing team is currently enabled only |cFF00FF00 in Celestial Tournament, Wailing Caverns pet battle dungeon and The Deadmines pet battle dungeon|r")
		end
		if silent then
			DEFAULT_CHAT_FRAME:AddMessage("Printing of message that the player is in wrong zone to use this addon is |cFFFF0000disabled|r")
		else
			DEFAULT_CHAT_FRAME:AddMessage("Printing of message that the player is in wrong zone to use this addon is |cFF00FF00enabled|r")
		end
	end
	if msg == "on" then
		wasnotrecognized = false
		doeverywhere = true
		settings.RematchCelestialTournament.do_everywhere = doeverywhere
		DEFAULT_CHAT_FRAME:AddMessage("Loading of healing team was enabled for each zone|r")
	end
	if msg == "off" then
		wasnotrecognized = false
		doeverywhere = false
		settings.RematchCelestialTournament.do_everywhere = doeverywhere
		DEFAULT_CHAT_FRAME:AddMessage("Loading of healing team was enabled to only Celestial Tournament, Wailing Caverns pet battle dungeon and The Deadmines pet battle dungeon|r")
	end
	if msg == "toggle" then
		wasnotrecognized = false
		doeverywhere = not doeverywhere
		settings.RematchCelestialTournament.do_everywhere = doeverywhere
		if doeverywhere then
			DEFAULT_CHAT_FRAME:AddMessage("Loading of healing team was toggled to be enabled |cFFFF0000in every zone|r")
		else
			DEFAULT_CHAT_FRAME:AddMessage("Loading of healing team was toggled to be enabled only in Celestial Tournament, Wailing Caverns pet battle dungeon and The Deadmines pet battle dungeon|r")
		end
	end
	if msg == "reset" then
		wasnotrecognized = false
		doeverywhere = false
		settings.RematchCelestialTournament.do_everywhere = doeverywhere
		DEFAULT_CHAT_FRAME:AddMessage("Loading of healing team was reset to be enabled only |cFF00FF00in Celestial Tournament, Wailing Caverns pet battle dungeon and The Deadmines pet battle dungeon|r")
	end
	if msg == "silent" then
		wasnotrecognized = false
		silent = true
		settings.RematchCelestialTournament.silent = silent
		DEFAULT_CHAT_FRAME:AddMessage("Printing of message that the player is in wrong zone to use this addon is |cFFFF0000disabled|r")
	end
	if msg == "verbose" then
		wasnotrecognized = false
		silent = false
		settings.RematchCelestialTournament.silent = silent
		DEFAULT_CHAT_FRAME:AddMessage("Printing of message that the player is in wrong zone to use this addon is |cFF00FF00enabled|r")
	end
	if wasnotrecognized then
		DEFAULT_CHAT_FRAME:AddMessage("Available comands:")
	--if msg == "" or wasnotrecognized then
		DEFAULT_CHAT_FRAME:AddMessage(" |cFFC0C0C0 /rmtcelest status|r - Displays current status of loading of healing team")
		DEFAULT_CHAT_FRAME:AddMessage(" |cFFC0C0C0/rmtcelest on|r - Enables loading of healing team |cFFFF0000in every zone|r")
		DEFAULT_CHAT_FRAME:AddMessage(" |cFFC0C0C0/rmtcelest off|r - Enables loading of healing team only |cFF00FF00in Celestial Tournament, Wailing Caverns pet battle dungeon and The Deadmines pet battle dungeon|r")
		DEFAULT_CHAT_FRAME:AddMessage(" |cFFC0C0C0/rmtcelest toggle|r - Toggles status of loading of healing team")
		DEFAULT_CHAT_FRAME:AddMessage(" |cFFC0C0C0/rmtcelest reset|r - Resets status of loading of healing team")
		DEFAULT_CHAT_FRAME:AddMessage(" |cFFC0C0C0/rmtcelest silent|r - |cFFFF0000Disables|r printing of message that the player is in wrong zone to use this addon")
		DEFAULT_CHAT_FRAME:AddMessage(" |cFFC0C0C0/rmtcelest verbose|r - |cFF00FF00Enables|r printing of message that the player is in wrong zone to use this addon")
	end
end




